
package com.inteligr8.alfresco.activiti.model;

import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;


/**
 * ModelRepresentation
 * <p>
 * 
 * 
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "comment",
    "createdBy",
    "createdByFullName",
    "description",
    "favorite",
    "id",
    "lastUpdated",
    "lastUpdatedBy",
    "lastUpdatedByFullName",
    "latestVersion",
    "modelType",
    "name",
    "permission",
    "referenceId",
    "stencilSet",
    "tenantId",
    "version"
})
public class ModelRepresentation {

    @JsonProperty("comment")
    private String comment;
    @JsonProperty("createdBy")
    private Integer createdBy;
    @JsonProperty("createdByFullName")
    private String createdByFullName;
    @JsonProperty("description")
    private String description;
    @JsonProperty("favorite")
    private Boolean favorite;
    @JsonProperty("id")
    private Integer id;
    @JsonProperty("lastUpdated")
    private String lastUpdated;
    @JsonProperty("lastUpdatedBy")
    private Integer lastUpdatedBy;
    @JsonProperty("lastUpdatedByFullName")
    private String lastUpdatedByFullName;
    @JsonProperty("latestVersion")
    private Boolean latestVersion;
    @JsonProperty("modelType")
    private Integer modelType;
    @JsonProperty("name")
    private String name;
    @JsonProperty("permission")
    private String permission;
    @JsonProperty("referenceId")
    private Integer referenceId;
    @JsonProperty("stencilSet")
    private Integer stencilSet;
    @JsonProperty("tenantId")
    private Integer tenantId;
    @JsonProperty("version")
    private Integer version;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();

    @JsonProperty("comment")
    public String getComment() {
        return comment;
    }

    @JsonProperty("comment")
    public void setComment(String comment) {
        this.comment = comment;
    }

    public ModelRepresentation withComment(String comment) {
        this.comment = comment;
        return this;
    }

    @JsonProperty("createdBy")
    public Integer getCreatedBy() {
        return createdBy;
    }

    @JsonProperty("createdBy")
    public void setCreatedBy(Integer createdBy) {
        this.createdBy = createdBy;
    }

    public ModelRepresentation withCreatedBy(Integer createdBy) {
        this.createdBy = createdBy;
        return this;
    }

    @JsonProperty("createdByFullName")
    public String getCreatedByFullName() {
        return createdByFullName;
    }

    @JsonProperty("createdByFullName")
    public void setCreatedByFullName(String createdByFullName) {
        this.createdByFullName = createdByFullName;
    }

    public ModelRepresentation withCreatedByFullName(String createdByFullName) {
        this.createdByFullName = createdByFullName;
        return this;
    }

    @JsonProperty("description")
    public String getDescription() {
        return description;
    }

    @JsonProperty("description")
    public void setDescription(String description) {
        this.description = description;
    }

    public ModelRepresentation withDescription(String description) {
        this.description = description;
        return this;
    }

    @JsonProperty("favorite")
    public Boolean getFavorite() {
        return favorite;
    }

    @JsonProperty("favorite")
    public void setFavorite(Boolean favorite) {
        this.favorite = favorite;
    }

    public ModelRepresentation withFavorite(Boolean favorite) {
        this.favorite = favorite;
        return this;
    }

    @JsonProperty("id")
    public Integer getId() {
        return id;
    }

    @JsonProperty("id")
    public void setId(Integer id) {
        this.id = id;
    }

    public ModelRepresentation withId(Integer id) {
        this.id = id;
        return this;
    }

    @JsonProperty("lastUpdated")
    public String getLastUpdated() {
        return lastUpdated;
    }

    @JsonProperty("lastUpdated")
    public void setLastUpdated(String lastUpdated) {
        this.lastUpdated = lastUpdated;
    }

    public ModelRepresentation withLastUpdated(String lastUpdated) {
        this.lastUpdated = lastUpdated;
        return this;
    }

    @JsonProperty("lastUpdatedBy")
    public Integer getLastUpdatedBy() {
        return lastUpdatedBy;
    }

    @JsonProperty("lastUpdatedBy")
    public void setLastUpdatedBy(Integer lastUpdatedBy) {
        this.lastUpdatedBy = lastUpdatedBy;
    }

    public ModelRepresentation withLastUpdatedBy(Integer lastUpdatedBy) {
        this.lastUpdatedBy = lastUpdatedBy;
        return this;
    }

    @JsonProperty("lastUpdatedByFullName")
    public String getLastUpdatedByFullName() {
        return lastUpdatedByFullName;
    }

    @JsonProperty("lastUpdatedByFullName")
    public void setLastUpdatedByFullName(String lastUpdatedByFullName) {
        this.lastUpdatedByFullName = lastUpdatedByFullName;
    }

    public ModelRepresentation withLastUpdatedByFullName(String lastUpdatedByFullName) {
        this.lastUpdatedByFullName = lastUpdatedByFullName;
        return this;
    }

    @JsonProperty("latestVersion")
    public Boolean getLatestVersion() {
        return latestVersion;
    }

    @JsonProperty("latestVersion")
    public void setLatestVersion(Boolean latestVersion) {
        this.latestVersion = latestVersion;
    }

    public ModelRepresentation withLatestVersion(Boolean latestVersion) {
        this.latestVersion = latestVersion;
        return this;
    }

    @JsonProperty("modelType")
    public Integer getModelType() {
        return modelType;
    }

    @JsonProperty("modelType")
    public void setModelType(Integer modelType) {
        this.modelType = modelType;
    }

    public ModelRepresentation withModelType(Integer modelType) {
        this.modelType = modelType;
        return this;
    }

    @JsonProperty("name")
    public String getName() {
        return name;
    }

    @JsonProperty("name")
    public void setName(String name) {
        this.name = name;
    }

    public ModelRepresentation withName(String name) {
        this.name = name;
        return this;
    }

    @JsonProperty("permission")
    public String getPermission() {
        return permission;
    }

    @JsonProperty("permission")
    public void setPermission(String permission) {
        this.permission = permission;
    }

    public ModelRepresentation withPermission(String permission) {
        this.permission = permission;
        return this;
    }

    @JsonProperty("referenceId")
    public Integer getReferenceId() {
        return referenceId;
    }

    @JsonProperty("referenceId")
    public void setReferenceId(Integer referenceId) {
        this.referenceId = referenceId;
    }

    public ModelRepresentation withReferenceId(Integer referenceId) {
        this.referenceId = referenceId;
        return this;
    }

    @JsonProperty("stencilSet")
    public Integer getStencilSet() {
        return stencilSet;
    }

    @JsonProperty("stencilSet")
    public void setStencilSet(Integer stencilSet) {
        this.stencilSet = stencilSet;
    }

    public ModelRepresentation withStencilSet(Integer stencilSet) {
        this.stencilSet = stencilSet;
        return this;
    }

    @JsonProperty("tenantId")
    public Integer getTenantId() {
        return tenantId;
    }

    @JsonProperty("tenantId")
    public void setTenantId(Integer tenantId) {
        this.tenantId = tenantId;
    }

    public ModelRepresentation withTenantId(Integer tenantId) {
        this.tenantId = tenantId;
        return this;
    }

    @JsonProperty("version")
    public Integer getVersion() {
        return version;
    }

    @JsonProperty("version")
    public void setVersion(Integer version) {
        this.version = version;
    }

    public ModelRepresentation withVersion(Integer version) {
        this.version = version;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public ModelRepresentation withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

}
